﻿using System;
using System.IO;

namespace HeuristicLab.PluginInfrastructure.Runner {
  class Program
  {
    static void Main(string[] args)
    {
      string basePath = Directory.GetCurrentDirectory();
      string[] activatorArgs = null;

      for(int i = 0; i < args.Length; ++i) {
        switch(args[i]) {
          case "--basePath":
            basePath = args[++i];
            break;
          case "--":
            activatorArgs = new string[args.Length - i - 1];
            for(int j = 0; j < activatorArgs.Length; ++j) {
              activatorArgs[j] = args[(i+1) + j];
            }
            break;
        }
      }

      

      IPluginLoader loader = PluginLoaderFactory.Create(basePath);

      Console.WriteLine($"{typeof(Program).FullName} --> basePath: {basePath}, activatorArgs: {activatorArgs.Length}, plugins: {loader.Plugins.Count}, activators: {loader.Activators.Count}");

      foreach (IActivator activator in loader.Activators)
        activator.Activate(new ActivatorContext(loader), activatorArgs);
    }
  }
}
